summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--ChangeLog3
-rwxr-xr-xtests/ls/inode42
2 files changed, 45 insertions, 0 deletions
diff --git a/ChangeLog b/ChangeLog
index c969068e1..3c84120b6 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -2,6 +2,9 @@
* Version 4.5.5.
+ * tests/ls/dangle: New test, for the above fix.
+ * tests/ls/inode: Another new test, for the above fix.
+
* src/ls.c (gobble_file): Fix a bug introduced in 4.5.4 that made it
so that ls --color would no longer highlight the names of files with
the execute bit set when not specified on the command line.
diff --git a/tests/ls/inode b/tests/ls/inode
new file mode 100755
index 000000000..f4bf38460
--- /dev/null
+++ b/tests/ls/inode
@@ -0,0 +1,42 @@
+#!/bin/sh
+# Make sure that ls -i works properly on symlinks.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ ls --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+touch f || framework_failure=1
+ln -s f slink || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+set x `ls -Ci f slink`; shift
+test $# = 4 || fail=1
+# The inode numbers should differ.
+test "$1" = "$3" && fail=1
+
+set x `ls -CLi f slink`; shift
+test $# = 4 || fail=1
+# With -L, they must be the same.
+test "$1" = "$3" || fail=1
+
+set x `ls -CHi f slink`; shift
+test $# = 4 || fail=1
+# With -H, they must differ.
+test "$1" = "$3" && fail=1
+
+(exit $fail); exit $fail